{*************************************************************}
{            TPathLabel component for Delphi 16/32            }
{ Version:   1.0                                              }
{ Author:    Aleksey Kuznetsov                                }
{ E-Mail:    info@utilmind.com                                }
{ Home Page: http://www.utilmind.com                          }
{ Created:   June, 3, 1999                                    }
{ Modified:  June, 3, 1999                                    }
{ Legal:     Copyright (c) 1999, UtilMind Solutions           }
{*************************************************************}
{ Component shows long path to file as 'c:\...\dir\filename'. }
{*************************************************************}
{ Please see demo program for more information.               }
{*************************************************************}
{                     IMPORTANT NOTE:                         }
{ This software is provided 'as-is', without any express or   }
{ implied warranty. In no event will the author be held       }
{ liable for any damages arising from the use of this         }
{ software.                                                   }
{ Permission is granted to anyone to use this software for    }
{ any purpose, including commercial applications, and to      }
{ alter it and redistribute it freely, subject to the         }
{ following restrictions:                                     }
{ 1. The origin of this software must not be misrepresented,  }
{    you must not claim that you wrote the original software. }
{    If you use this software in a product, an acknowledgment }
{    in the product documentation would be appreciated but is }
{    not required.                                            }
{ 2. Altered source versions must be plainly marked as such,  }
{    and must not be misrepresented as being the original     }
{    software.                                                }
{ 3. This notice may not be removed or altered from any       }
{    source distribution.                                     }
{*************************************************************}
unit Pathlab;

interface

uses
  {$IFNDEF Win32}  SysUtils, {$ENDIF}
  Classes, Forms, StdCtrls, DsgnIntf;

type
  TPathLabel = class(TLabel)
  private
    FCaption: String;

    procedure SetCaption(Value: String);
  public
    constructor Create(aOwner: TComponent); override;
  published
    property Caption: String read FCaption write SetCaption;
  end;

  TAutoSizeProperty = class(TClassProperty)
  public
    function GetValue: String; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

implementation

constructor TPathLabel.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  try
   Height := TForm(aOwner).Canvas.TextHeight('Aj|');
  except
  end;
  AutoSize := False;
end;

procedure TPathLabel.SetCaption(Value: String);
label LAB, LAB2; { ;-D }
var
{$IFNDEF Win32}
  PC: Array[0..$FFF] of Char;
{$ENDIF}
  BeginP, EndP: Integer;
  St: String;
begin
  FCaption := Value;
  if Canvas.TextWidth(Value) > Width then
   begin
    St := Value + '\...';
    while Canvas.TextWidth(St) > Width do
     begin
      BeginP := Pos('\', St);
      if BeginP = 0 then 
  {10}  GOTO LAB2;  { ;-)) }
      Delete(St, BeginP, 1);
      EndP := Pos('\', St);
      if EndP = Length(St) - 3 then 
       begin
        Insert('\', St, 3);
  {20}  GOTO LAB;  { ;-))))) }
       end;
      Delete(St, BeginP, EndP - BeginP);
     end;
    {$IFDEF Win32}
    SetLength(St, Length(St) - 4);    
    {$ELSE}
    St[0] := Char(Length(St) - 4);
    {$ENDIF}
LAB:
    Insert('\...', St, 3);
    Value := St;
LAB2:
   end;
  {$IFDEF Win32}
  SetTextBuf(PChar(Value));
  {$ELSE}
  StrPCopy(PC, Value);
  SetTextBuf(PC);
  {$ENDIF}
end;

function TAutoSizeProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paReadOnly]
end;

function TAutoSizeProperty.GetValue: String;
begin
  Result := '(Obsolete)';
end;

procedure Register;
begin
  RegisterComponents('UtilMind', [TPathLabel]);
  RegisterPropertyEditor(TypeInfo(Boolean), TPathLabel,
                         'AutoSize', TAutoSizeProperty);
end;

end.
 